;Auto Alpha-Lock Off 1.15
;Copyright (C) Kevin Kofler, 2000-2005
;please read the readme file before using this file
;Please DO NOT distribute modified versions without my
;permission!

 include "OS.h" ;You need the version included with TIGCC.
_tigcc_native: xdef _tigcc_native ;no kernel required, but startup sections
 xdef _ti89 ;This is only for the TI-89.

 section "_st1"

 xdef _nostub_data__0000 ;comment
 xdef _nostub_data__0006 ;incompatibility flags

 include "h220xtsr.h" ;include my Hardware 2.00 AMS 2 TSR support
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 moveq.l #-5,d1
 moveq.l #16,d3 ;compute offset
 cmp.l d0,d1
 beq hw3
 bset.l #18,d3
hw3:
 move.l $c8,a0
 move.l ScrRect*4(a0),a1
 cmp.b #200,2(a1) ;check if TI-92+/V200
 bcs notti92plus
 pea.l ti92plusST(PC) ;(no alpha-lock to disable on a TI-92+)
 bra showmsg ;display an error message on a TI-92+
notti92plus:
 cmp.l #1000,-4(a0) ;check if more than 1000 entries
 bcc notams1 ;if no, it is AMS 1.xx
 pea.l ams1ST(PC) ;(no auto-alpha-lock to disable on AMS 1)
 bra showmsg ;display an error message on AMS 1
notams1:
 ROM_CALL2 EV_hook ;get the location of the event hook
 move.l (a4),oldevent ;save the old event hook and call
                      ;it from the event routine
 move.l #(endevent-newevent),-(a7)
 ROM_CALL HeapAllocHigh ;allocate a handle for the new
                        ;event routine
 addq.l #2,a7
 tst.w d0 ;check if NULL handle
 bne memok ;if yes, display "no mem" error message
 addq.l #2,a7 ;adjust the stack
 pea.l nomemST(PC) ;show "no mem" message
 bra showmsg
memok:
 move.w d0,(a7)
 ROM_CALL HeapDeref ;get ("dereference") the address
 move.l a0,a3 ;save the address to a3 for further use
 subq.l #2,a7
 move.l #(endevent-newevent),(a7)
 pea.l newevent(PC)
 move.l a0,-(a7)
 ROM_CALL memcpy ;copy the event routine to the handle
 lea.l 12(a7),a7 ;shorter as add(a).l #12,a7
 ROM_CALL2 EV_hook ;get the location of the event hook
 adda.l d3,a3 ;add offset to skip the uninstall information (need the start of
              ;the executable code here)
 move.l a3,(a4) ;install the event hook
 pea.l installedST(PC) ;show "installed" message
showmsg:
 ROM_CALL ST_helpMsg
 addq.l #4,a7
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return

newevent: ;event hook
 dc.b 'evHkAuto',128,'Off' ;signature "evHk" + program name
                           ;(for event hook uninstaller)
oldevent: dc.l 0 ;placeholder for old event hook
                 ;0 if none
                 ;placed here for easier and
                 ;program- and version-independent
                 ;uninstalling
 movem.l a0-a6/d0-d7,-(a7) ;save all registers
 move.l 64(a7),a2 ;a2=event structure address (a2 for TEOS)
 lea.l useralpha(PC),a5 ;(a5) = "user alpha-lock" flag
 cmpa.l #$4100,a2 ;check if in a dialog
 bcc notalpha ;if not, do nothing
 ; The above is a dirty trick which should be explained:
 ; We get passed from AMS some event structure located on the
 ; stack. Obviously, the position depends on the stack level
 ; in the routine sending the event (EV_sendEventSide). If we
 ; are not in a dialog, the event structure is at some address
 ; in the 0x41xx range. The exact address depends on the AMS
 ; version, that's why I use a >= comparison rather than an
 ; == comparison. If we are in a dialog though, there is lots
 ; of stuff on the stack, so we get some address in the 0x3xxx
 ; range.
 cmp.w #$710,(a2) ;check if CM_KEYPRESS
 bne notkeypress ;if not, proceed
 cmp.w #278,10(a2) ;check if Catalog
 beq useralphaon ;if yes, turn on the "user alpha-lock"
                 ;flag
 ;Check if the user pressed alpha-lock here:
 btst.b #5,7(a2) ;if yes, check status flags for alpha-lock
 beq useralphaoff ;if off, turn off the "user alpha-lock"
                  ;flag
useralphaon:
 st.b (a5) ;turn on the "user alpha-lock" flag 
 bra notalpha ;do nothing more
notkeypress:
 ;Disable the "user alpha lock" if we are exiting a dialog
 ;or a sequence of dialogs here:
 cmp.w #$760,(a2) ;check if CM_WPAINT
 bne notrepaint ;if not, proceed
useralphaoff:
 clr.b (a5) ;if yes, turn off the "user alpha-lock" flag
 bra notalpha ;do nothing more
notrepaint:
 cmp.w #$700,(a2) ;check if CM_IDLE
 bne notalpha ;if not, do nothing
 move.w 6(a2),d0 ;d0 = status flags
 and.w #$a020,d0 ;mask out all annoying mode indicators
 cmp.w #$a020,d0 ;check status flags for auto alpha-lock
 ;This is in fact the status flag for "status line text on
 ;and changed and alpha-lock on":
 ;- $8000: status line text on
 ;- $2000: status line text changed
 ;- $0020: alpha-lock on
 ;Thus the checks for:
 ;- if we are in a dialog
 ;- if alpha-lock is on because the user pressed it in the
 ;  same dialog (and the status line text has changed due
 ;  to the navigation in the dialog)
 bne notalpha ;if not, do nothing
 tst.b (a5) ;check if the user has activated alpha-lock in
            ;this dialog
 bne notalpha ;if yes, do nothing
 move.l $c8,a4
 clr.w -(a7) ;FALSE
 move.l SetAlphaStatus*4(a4),a0
 jsr (a0) ;turn alpha-lock off
 clr.w (a7)
 move.l ST_modKey*4(a4),a0
 jsr (a0) ;adjust the status flag: * of the AMS
 addq.l #2,a7
 bclr.b #5,7(a2) ;                 * of the event structure
notalpha:
 move.l oldevent(PC),a0 ;a0 = old event hook
 cmp.l #0,a0 ;check if 0 (tst refuses this addressing mode)
 beq nooldevent ;if 0 do nothing
 move.l a2,-(a7) ;pass event structure as an argument
 jsr (a0) ;run the old event hook
 addq.l #4,a7
nooldevent:
 movem.l (a7)+,a0-a6/d0-d7 ;restore all registers
 rts ;return
useralpha: dc.b 0
endevent:

_nostub_data__0006: ;incompatibility flags
 dc.l 11 ;incompatible with handle freeing, EV_hook and trap restoring

installedST: dc.b 'Auto',128,'Off 1.15 by Kevin Kofler installed',0
ams1ST: dc.b 'ERROR: no auto-',128,'lock to disable on AMS1',0
nomemST: dc.b 'ERROR: not enough memory',0
ti92plusST: dc.b 'ERROR: no alpha-lock to disable on a TI-92+/Voyage 200',0

_nostub_data__0000: ;comment
 dc.b 'Auto ',128,'Lock Off 1.15 by Kevin Kofler',0

  END
